/*
 * ioGame
 * Copyright (C) 2021 - 2023  渔民小镇 （262610965@qq.com、luoyizhu@gmail.com） . All Rights Reserved.
 * # iohao.com . 渔民小镇
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.iohao.mmo.person.service;

import com.iohao.mmo.person.entity.BasicsProperty;
import com.iohao.mmo.person.entity.Person;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.FieldDefaults;

/**
 * @author 渔民小镇
 * @date 2023-07-24
 */
@Getter
@Setter
@FieldDefaults(level = AccessLevel.PRIVATE)
public class PersonService {
    public Person getPersonEntity(String userId) {
        //  临时数据
        BasicsProperty basicProperty = getBasicPropertyTemp();

        Person person = new Person();
        person.setBasicProperty(basicProperty);
        return person;
    }

    public static BasicsProperty getBasicPropertyTemp() {
        BasicsProperty basicProperty = new BasicsProperty();
        basicProperty.setHp(100);
        basicProperty.setMp(100);
        basicProperty.setPhysicsAttack(20);
        basicProperty.setPhysicsDefense(10);

        basicProperty.setMagicAttack(20);
        basicProperty.setMagicDefense(10);

        basicProperty.setTreatAttack(20);
        basicProperty.setSealAttack(20);
        basicProperty.setSealDefense(10);
        basicProperty.setSpeed(50);
        basicProperty.setAnger(0);
        return basicProperty;
    }
}
